diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-helper-test.cc ns-3.42/src/buildings/test/buildings-helper-test.cc
--- ns-3.41/src/buildings/test/buildings-helper-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-helper-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -32,7 +32,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * \brief Struct representing a position in a building
  */
@@ -59,7 +58,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
 
  * Data to construct a Building object. We don't want to pass Building
  * objects to the TestCase constructor because otherwise BuildingList
@@ -96,7 +94,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * \brief BuildingsHelper test
  */
@@ -197,7 +194,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * \brief BuildingsHelper TestSuite
  */
@@ -208,7 +204,7 @@
 };
 
 BuildingsHelperTestSuite::BuildingsHelperTestSuite()
-    : TestSuite("buildings-helper", UNIT)
+    : TestSuite("buildings-helper", Type::UNIT)
 {
     NS_LOG_FUNCTION(this);
 
@@ -231,25 +227,25 @@
     p1.rx = 1;
     p1.ry = 1;
     p1.fn = 1;
-    AddTestCase(new BuildingsHelperOneTestCase(p1, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p1, b1), TestCase::Duration::QUICK);
 
     Vector vp2(1.5, 0.5, 0.5);
     PositionInBuilding p2;
     p2.pos = vp2;
     p2.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p2, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p2, b1), TestCase::Duration::QUICK);
 
     Vector vp3(1.5, 2.5, 0.5);
     PositionInBuilding p3;
     p3.pos = vp3;
     p3.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p3, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p3, b1), TestCase::Duration::QUICK);
 
     Vector vp4(1.5, 1.5, 5);
     PositionInBuilding p4;
     p4.pos = vp4;
     p4.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p4, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p4, b1), TestCase::Duration::QUICK);
 
     Vector vp5(2.5, 1.6, 3.5);
     PositionInBuilding p5;
@@ -259,31 +255,31 @@
     p5.rx = 1;
     p5.ry = 1;
     p5.fn = 1;
-    AddTestCase(new BuildingsHelperOneTestCase(p5, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p5, b1), TestCase::Duration::QUICK);
 
     Vector vp6(0.9999, 1.5, 1.5);
     PositionInBuilding p6;
     p6.pos = vp6;
     p6.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p6, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p6, b1), TestCase::Duration::QUICK);
 
     Vector vp7(3.0001, 1.5, 2.5);
     PositionInBuilding p7;
     p7.pos = vp7;
     p7.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p7, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p7, b1), TestCase::Duration::QUICK);
 
     Vector vp8(1.001, 1.001, -0.01);
     PositionInBuilding p8;
     p8.pos = vp8;
     p8.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p8, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p8, b1), TestCase::Duration::QUICK);
 
     Vector vp9(1.5, 1.5, 4.001);
     PositionInBuilding p9;
     p9.pos = vp9;
     p9.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(p9, b1), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(p9, b1), TestCase::Duration::QUICK);
 
     BuildingData b2;
     b2.xmin = -1;
@@ -304,7 +300,7 @@
     q1.rx = 1;
     q1.ry = 2;
     q1.fn = 3;
-    AddTestCase(new BuildingsHelperOneTestCase(q1, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q1, b2), TestCase::Duration::QUICK);
 
     Vector vq2(0.2, 0.3, 0.2);
     PositionInBuilding q2;
@@ -314,37 +310,37 @@
     q2.rx = 3;
     q2.ry = 5;
     q2.fn = 1;
-    AddTestCase(new BuildingsHelperOneTestCase(q2, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q2, b2), TestCase::Duration::QUICK);
 
     Vector vq3(0.6, -1.75, 1.5);
     PositionInBuilding q3;
     q3.pos = vq3;
     q3.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(q3, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q3, b2), TestCase::Duration::QUICK);
 
     Vector vq4(-1.01, 0.3, 1.99);
     PositionInBuilding q4;
     q4.pos = vq4;
     q4.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(q4, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q4, b2), TestCase::Duration::QUICK);
 
     Vector vq5(-0.8, 0.7, 0.01);
     PositionInBuilding q5;
     q5.pos = vq5;
     q5.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(q5, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q5, b2), TestCase::Duration::QUICK);
 
     Vector vq6(0.2, 0.3, -0.2);
     PositionInBuilding q6;
     q6.pos = vq6;
     q6.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(q6, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q6, b2), TestCase::Duration::QUICK);
 
     Vector vq7(0.2, 0.3, 2.001);
     PositionInBuilding q7;
     q7.pos = vq7;
     q7.indoor = false;
-    AddTestCase(new BuildingsHelperOneTestCase(q7, b2), TestCase::QUICK);
+    AddTestCase(new BuildingsHelperOneTestCase(q7, b2), TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-pathloss-test.cc ns-3.42/src/buildings/test/buildings-pathloss-test.cc
--- ns-3.41/src/buildings/test/buildings-pathloss-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-pathloss-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -41,7 +41,7 @@
  * several communication scenarios
  */
 BuildingsPathlossTestSuite::BuildingsPathlossTestSuite()
-    : TestSuite("buildings-pathloss-test", SYSTEM)
+    : TestSuite("buildings-pathloss-test", Type::SYSTEM)
 {
     LogComponentEnable("BuildingsPathlossTest", LOG_LEVEL_ALL);
 
@@ -54,7 +54,7 @@
                                               LargeCity,
                                               137.93,
                                               "OH Urban Large city"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     AddTestCase(new BuildingsPathlossTestCase(freq,
                                               1,
@@ -63,7 +63,7 @@
                                               SmallCity,
                                               137.88,
                                               "OH Urban small city"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     AddTestCase(new BuildingsPathlossTestCase(freq,
                                               1,
@@ -72,7 +72,7 @@
                                               LargeCity,
                                               128.03,
                                               "loss OH SubUrban"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     AddTestCase(new BuildingsPathlossTestCase(freq,
                                               1,
@@ -81,7 +81,7 @@
                                               LargeCity,
                                               110.21,
                                               "loss OH OpenAreas"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #2 COST231 Model (1500 < freq < 2000~2170 MHz) (Macro<->UE)
 
@@ -94,7 +94,7 @@
                                               LargeCity,
                                               148.55,
                                               "COST231 Urban Large city"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     AddTestCase(new BuildingsPathlossTestCase(freq,
                                               1,
@@ -103,7 +103,7 @@
                                               SmallCity,
                                               150.64,
                                               "COST231 Urban small city and suburban"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #3 2.6 GHz model (Macro<->UE)
 
@@ -116,7 +116,7 @@
                                               SmallCity,
                                               121.83,
                                               "2.6GHz model"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #4 ITU1411 LOS model (Macro<->UE)
 
@@ -128,7 +128,7 @@
                                               LargeCity,
                                               81.00,
                                               "ITU1411 LOS"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #5 ITU1411 NLOS model (Macro<->UE)
 
@@ -141,14 +141,14 @@
                                               LargeCity,
                                               143.69,
                                               "ITU1411 NLOS"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #6 ITUP1238 (HeNB <-> UE)
 
     freq = 2.1140e9; // E_UTRA BAND #1 see table 5.5-1 of 36.101
     AddTestCase(
         new BuildingsPathlossTestCase(freq, 5, 6, UrbanEnvironment, LargeCity, 88.3855, "ITUP1238"),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // Test #7 Outdoor -> Indoor OkumuraHata (Macro<->UE)
 
@@ -162,7 +162,7 @@
                                               LargeCity,
                                               155.55,
                                               "Okumura Hata Outdoor -> Indoor"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #8 Outdoor -> Indoor ITU1411 (Macro<->UE)
     freq = 2.1140e9; // E_UTRA BAND #1 see table 5.5-1 of 36.101
@@ -175,7 +175,7 @@
                                               LargeCity,
                                               88.000,
                                               "ITU1411 LOS Outdoor -> Indoor"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #9 Indoor -> Outdoor LOS (HeNB <-> UE)
 
@@ -190,7 +190,7 @@
                                               LargeCity,
                                               84.838,
                                               "ITU1411 LOS Indoor -> Outdoor"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #10 Indoor -> Outdoor NLOS (HeNB <-> UE)
 
@@ -205,7 +205,7 @@
                                               LargeCity,
                                               183.90,
                                               "ITU1411 NLOS Indoor -> Outdoor"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-pathloss-test.h ns-3.42/src/buildings/test/buildings-pathloss-test.h
--- ns-3.41/src/buildings/test/buildings-pathloss-test.h	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-pathloss-test.h	2024-05-29 15:29:46.924073000 -0700
@@ -27,7 +27,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test 1.1 BuildingsPathlossModel Pathloss compound test
  *
@@ -42,7 +41,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test 1.1 BuildingsPathlossModel Pathloss test
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-penetration-loss-pathloss-test.cc ns-3.42/src/buildings/test/buildings-penetration-loss-pathloss-test.cc
--- ns-3.41/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -79,7 +79,6 @@
         Vector m_positionA; //!< the position of the first node
         Vector m_positionB; //!< the position of the second node
         double m_frequency; //!< carrier frequency in Hz
-        bool m_isLos;       //!< LOS probability
         TypeId m_condModel; //!< the type ID of the channel condition model to be used
         TypeId m_propModel; //!< the type ID of the propagation loss model to be used
         double m_pt;        //!< transmitted power in dBm
@@ -271,9 +270,9 @@
 };
 
 BuildingsPenetrationLossesTestSuite::BuildingsPenetrationLossesTestSuite()
-    : TestSuite("buildings-penetration-losses", UNIT)
+    : TestSuite("buildings-penetration-losses", Type::UNIT)
 {
-    AddTestCase(new BuildingsPenetrationLossesTestCase, TestCase::QUICK);
+    AddTestCase(new BuildingsPenetrationLossesTestCase, TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-shadowing-test.cc ns-3.42/src/buildings/test/buildings-shadowing-test.cc
--- ns-3.41/src/buildings/test/buildings-shadowing-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-shadowing-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -45,21 +45,21 @@
  */
 
 BuildingsShadowingTestSuite::BuildingsShadowingTestSuite()
-    : TestSuite("buildings-shadowing-test", SYSTEM)
+    : TestSuite("buildings-shadowing-test", Type::SYSTEM)
 {
     LogComponentEnable("BuildingsShadowingTest", LOG_LEVEL_ALL);
 
     // Test #1 Outdoor Model
     AddTestCase(new BuildingsShadowingTestCase(1, 2, 148.86, 7.0, "Outdoor Shadowing"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #2 Indoor model
     AddTestCase(new BuildingsShadowingTestCase(5, 6, 88.5724, 8.0, "Indoor Shadowing"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Test #3 Indoor -> Outdoor
     AddTestCase(new BuildingsShadowingTestCase(9, 10, 85.0012, 8.6, "Indoor -> Outdoor Shadowing"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/buildings-shadowing-test.h ns-3.42/src/buildings/test/buildings-shadowing-test.h
--- ns-3.41/src/buildings/test/buildings-shadowing-test.h	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/buildings-shadowing-test.h	2024-05-29 15:29:46.924073000 -0700
@@ -32,7 +32,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Shadowing compound test
  *
@@ -47,7 +46,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Shadowing test
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/outdoor-random-walk-test.cc ns-3.42/src/buildings/test/outdoor-random-walk-test.cc
--- ns-3.41/src/buildings/test/outdoor-random-walk-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/outdoor-random-walk-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test case for the class OutdoorRandomWalkTestCase. It checks if the
  * positions visited by the user are outside buildings
@@ -164,7 +163,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test suite for the buildings channel condition model
  */
@@ -175,9 +173,9 @@
 };
 
 OutdoorRandomWalkTestSuite::OutdoorRandomWalkTestSuite()
-    : TestSuite("outdoor-random-walk-model", UNIT)
+    : TestSuite("outdoor-random-walk-model", Type::UNIT)
 {
-    AddTestCase(new OutdoorRandomWalkTestCase, TestCase::QUICK);
+    AddTestCase(new OutdoorRandomWalkTestCase, TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc ns-3.42/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc
--- ns-3.41/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2024-02-09 14:44:07.865790000 -0800
+++ ns-3.42/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2024-05-29 15:29:46.924073000 -0700
@@ -38,7 +38,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test case for the classes ThreeGppV2vUrbanChannelConditionModel,
  * and ThreeGppV2vHighwayChannelConditionModel to test their code to
@@ -511,7 +510,6 @@
 
 /**
  * \ingroup building-test
- * \ingroup tests
  *
  * Test suite for the 3GPP V2V channel condition model
  *
@@ -539,17 +537,17 @@
 };
 
 ThreeGppV2vChCondModelsTestSuite::ThreeGppV2vChCondModelsTestSuite()
-    : TestSuite("three-gpp-v2v-channel-condition-model", SYSTEM)
+    : TestSuite("three-gpp-v2v-channel-condition-model", Type::SYSTEM)
 {
     AddTestCase(new ThreeGppV2vBuildingsChCondModelTestCase,
-                TestCase::QUICK); // test for the deterministic procedure (NLOS vs LOS/NLOSv), based
-                                  // on buildings
+                TestCase::Duration::QUICK); // test for the deterministic procedure (NLOS vs
+                                            // LOS/NLOSv), based on buildings
     AddTestCase(new ThreeGppV2vUrbanLosNlosvChCondModelTestCase,
-                TestCase::QUICK); // test for the probabilistic procedure (LOS vs NLOSv), in V2V
-                                  // urban scenario
+                TestCase::Duration::QUICK); // test for the probabilistic procedure (LOS vs
+                                            // NLOSv), in V2V urban scenario
     AddTestCase(new ThreeGppV2vHighwayLosNlosvChCondModelTestCase,
-                TestCase::QUICK); // test for the probabilistic procedure (LOS vs NLOSv), in V2V
-                                  // highway scenario
+                TestCase::Duration::QUICK); // test for the probabilistic procedure (LOS vs
+                                            // NLOSv), in V2V highway scenario
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/click/test/ipv4-click-routing-test.cc ns-3.42/src/click/test/ipv4-click-routing-test.cc
--- ns-3.41/src/click/test/ipv4-click-routing-test.cc	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/click/test/ipv4-click-routing-test.cc	2024-05-29 15:29:46.928073200 -0700
@@ -31,12 +31,18 @@
 using namespace ns3;
 
 /**
+ * \ingroup click
+ * \defgroup click-tests click module tests
+ */
+
+/**
  * \file
  * \ingroup click-tests
  * Click test suite.
  */
 
 /**
+ * \ingroup click-tests
  * Add Click Internet stack.
  *
  * \param node Node.
@@ -50,6 +56,7 @@
 }
 
 /**
+ * \ingroup click-tests
  * Add network device.
  *
  * \param node Node.
@@ -243,11 +250,11 @@
 {
   public:
     ClickIfidFromNameTestSuite()
-        : TestSuite("routing-click", UNIT)
+        : TestSuite("routing-click", Type::UNIT)
     {
-        AddTestCase(new ClickTrivialTest, TestCase::QUICK);
-        AddTestCase(new ClickIfidFromNameTest, TestCase::QUICK);
-        AddTestCase(new ClickIpMacAddressFromNameTest, TestCase::QUICK);
+        AddTestCase(new ClickTrivialTest, TestCase::Duration::QUICK);
+        AddTestCase(new ClickIfidFromNameTest, TestCase::Duration::QUICK);
+        AddTestCase(new ClickIpMacAddressFromNameTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/CMakeLists.txt ns-3.42/src/CMakeLists.txt
--- ns-3.41/src/CMakeLists.txt	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/src/CMakeLists.txt	2024-05-29 15:29:46.916073000 -0700
@@ -21,6 +21,38 @@
   endif()
 endforeach()
 
+# Scan for disabled modules that define settings prefixed with NS3_ or ENABLE_
+# so that we can initialize them as turned off (setting as temporary variables
+# not to affect the cached variables that are set when normally processed)
+subdirlist(modules ${CMAKE_CURRENT_SOURCE_DIR})
+foreach(libname ${modules})
+  if(NOT (${libname} IN_LIST libs))
+    # Skip module directories without CMakeLists.txt files
+    if(NOT (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt))
+      continue()
+    endif()
+
+    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${libname}/CMakeLists.txt
+         lib_cmakelists_contents
+    )
+    string(REGEX MATCHALL "(NS3_[a-zA-Z0-9_]*)|(ENABLE_[a-zA-Z0-9_]*)" flags
+                 "${lib_cmakelists_contents}"
+    )
+    foreach(flag ${flags})
+      # Skip reason flags
+      if(${flag} MATCHES "REASON")
+        continue()
+      endif()
+      # Skip flags already defined
+      if(DEFINED ${flag})
+        continue()
+      endif()
+      # Set flag to off
+      set(${flag} OFF PARENT_SCOPE)
+    endforeach()
+  endif()
+endforeach()
+
 # Prevents link errors due to symbol collisions if the same library is linked
 # multiple times
 list(REMOVE_DUPLICATES ns3-external-libs)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/config-store/examples/config-store-save.cc ns-3.42/src/config-store/examples/config-store-save.cc
--- ns-3.41/src/config-store/examples/config-store-save.cc	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/config-store/examples/config-store-save.cc	2024-05-29 15:29:46.928073200 -0700
@@ -6,8 +6,13 @@
 using namespace ns3;
 
 /**
- * \ingroup configstore-examples
+ * \defgroup configstore-examples Config Store examples
+ * \ingroup configstore
  * \ingroup examples
+ */
+
+/**
+ * \ingroup configstore-examples
  *
  * \brief Example class to demonstrate use of the ns-3 Config Store
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/config-store/model/display-functions.cc ns-3.42/src/config-store/model/display-functions.cc
--- ns-3.41/src/config-store/model/display-functions.cc	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/config-store/model/display-functions.cc	2024-05-29 15:29:46.928073200 -0700
@@ -84,20 +84,15 @@
                      node->object->GetInstanceTypeId().GetName().c_str(),
                      nullptr);
         break;
+    case ModelNode::NODE_ATTRIBUTE:
     case ModelNode::NODE_POINTER:
-        g_object_set(renderer, "text", node->name.c_str(), nullptr);
-        break;
     case ModelNode::NODE_VECTOR:
         g_object_set(renderer, "text", node->name.c_str(), nullptr);
         break;
-    case ModelNode::NODE_VECTOR_ITEM: {
+    case ModelNode::NODE_VECTOR_ITEM:
         std::stringstream oss;
         oss << node->index;
         g_object_set(renderer, "text", oss.str().c_str(), nullptr);
-    }
-    break;
-    case ModelNode::NODE_ATTRIBUTE:
-        g_object_set(renderer, "text", node->name.c_str(), nullptr);
         break;
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/CMakeLists.txt ns-3.42/src/core/CMakeLists.txt
--- ns-3.41/src/core/CMakeLists.txt	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/core/CMakeLists.txt	2024-05-29 15:29:46.928073200 -0700
@@ -137,7 +137,6 @@
     model/timer.cc
     model/watchdog.cc
     model/synchronizer.cc
-    model/make-event.cc
     model/environment-variable.cc
     model/log.cc
     model/breakpoint.cc
@@ -228,7 +227,6 @@
     model/hash-murmur3.h
     model/hash.h
     model/heap-scheduler.h
-    model/int-to-type.h
     model/int64x64-double.h
     model/int64x64.h
     model/integer.h
@@ -258,6 +256,7 @@
     model/rng-stream.h
     model/scheduler.h
     model/show-progress.h
+    model/shuffle.h
     model/simple-ref-count.h
     model/simulation-singleton.h
     model/simulator-impl.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/examples/empirical-random-variable-example.cc ns-3.42/src/core/examples/empirical-random-variable-example.cc
--- ns-3.41/src/core/examples/empirical-random-variable-example.cc	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/core/examples/empirical-random-variable-example.cc	2024-05-29 15:29:46.928073200 -0700
@@ -29,9 +29,13 @@
 #include <map>
 
 /**
- * \file
- * \ingroup core-examples randomvariable
  * \defgroup empirical-rng-example Core example: Empirical random variables use.
+ * \ingroup core-examples randomvariable
+ */
+
+/**
+ * \file
+ * \ingroup empirical-rng-example
  *
  * Example program illustrating use of ns3::EmpiricalRandomVariable
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/examples/sample-rng-plot.py ns-3.42/src/core/examples/sample-rng-plot.py
--- ns-3.41/src/core/examples/sample-rng-plot.py	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/core/examples/sample-rng-plot.py	2024-05-29 15:29:46.928073200 -0700
@@ -47,7 +47,7 @@
     # mu, var = 100, 225
 
     ## Random number generator.
-    rng = ns.CreateObject("NormalRandomVariable")
+    rng = ns.CreateObject[ns.NormalRandomVariable]()
     rng.SetAttribute("Mean", ns.DoubleValue(100.0))
     rng.SetAttribute("Variance", ns.DoubleValue(225.0))
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/examples/sample-simulator.py ns-3.42/src/core/examples/sample-simulator.py
--- ns-3.41/src/core/examples/sample-simulator.py	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/core/examples/sample-simulator.py	2024-05-29 15:29:46.928073200 -0700
@@ -38,7 +38,7 @@
 ## Example function - triggered at a random time.
 ## \return None.
 def RandomFunction():
-    print("RandomFunction received event at", ns.core.Simulator.Now().GetSeconds(), "s")
+    print("RandomFunction received event at", ns.Simulator.Now().GetSeconds(), "s")
 
 
 ## Example function - triggered if an event is canceled (should not be called).
@@ -119,23 +119,23 @@
     cmd.Parse(argv)
 
     model = ns.cppyy.gbl.MyModel()
-    v = ns.CreateObject("UniformRandomVariable")
-    v.SetAttribute("Min", ns.core.DoubleValue(10))
-    v.SetAttribute("Max", ns.core.DoubleValue(20))
+    v = ns.CreateObject[ns.UniformRandomVariable]()
+    v.SetAttribute("Min", ns.DoubleValue(10))
+    v.SetAttribute("Max", ns.DoubleValue(20))
 
     ev = ns.cppyy.gbl.ExampleFunctionEvent(model)
-    ns.core.Simulator.Schedule(ns.core.Seconds(10.0), ev)
+    ns.Simulator.Schedule(ns.Seconds(10.0), ev)
 
     ev2 = ns.cppyy.gbl.RandomFunctionEvent(model)
-    ns.core.Simulator.Schedule(ns.core.Seconds(v.GetValue()), ev2)
+    ns.Simulator.Schedule(ns.Seconds(v.GetValue()), ev2)
 
     ev3 = ns.cppyy.gbl.CancelledFunctionEvent()
-    id = ns.core.Simulator.Schedule(ns.core.Seconds(30.0), ev3)
-    ns.core.Simulator.Cancel(id)
+    id = ns.Simulator.Schedule(ns.Seconds(30.0), ev3)
+    ns.Simulator.Cancel(id)
 
-    ns.core.Simulator.Run()
+    ns.Simulator.Run()
 
-    ns.core.Simulator.Destroy()
+    ns.Simulator.Destroy()
 
 
 if __name__ == "__main__":
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/helper/csv-reader.cc ns-3.42/src/core/helper/csv-reader.cc
--- ns-3.41/src/core/helper/csv-reader.cc	2024-02-09 14:44:07.869789800 -0800
+++ ns-3.42/src/core/helper/csv-reader.cc	2024-05-29 15:29:46.928073200 -0700
@@ -31,7 +31,6 @@
 
 /**
  * \file
- * \ingroup core
  * \ingroup csvreader
  *
  * ns3::CsvReader implementation
@@ -460,7 +459,6 @@
         }
         break;
         case State::FIND_DELIMITER:
-            break;
         case State::END:
             break;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/helper/csv-reader.h ns-3.42/src/core/helper/csv-reader.h
--- ns-3.41/src/core/helper/csv-reader.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/helper/csv-reader.h	2024-05-29 15:29:46.928073200 -0700
@@ -29,7 +29,6 @@
 
 /**
  * \file
- * \ingroup core
  * \ingroup csvreader
  *
  * ns3::CsvReader declaration
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/attribute-container.h ns-3.42/src/core/model/attribute-container.h
--- ns-3.41/src/core/model/attribute-container.h	2024-02-09 14:44:07.873789800 -0800
+++ ns-3.42/src/core/model/attribute-container.h	2024-05-29 15:29:46.928073200 -0700
@@ -34,10 +34,18 @@
 namespace ns3
 {
 
+/*!
+ * \ingroup attributes
+ * \addtogroup attribute_AttributeContainer AttributeContainer Attribute
+ * AttributeValue implementation for AttributeContainer
+ */
+
 class AttributeChecker;
 
 // A = attribute value type, C = container type to return
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * A container for one type of attribute.
  *
  * The container uses \p A to parse items into elements.
@@ -186,11 +194,18 @@
      * \return This object with items copied.
      */
     template <class ITER>
-    Ptr<AttributeContainerValue<A, Sep, C>> CopyFrom(const ITER begin, const ITER end);
+    inline Ptr<AttributeContainerValue<A, Sep, C>> CopyFrom(const ITER begin, const ITER end);
 
     container_type m_container; //!< Internal container
 };
 
+/*!
+ * \ingroup attribute_AttributeContainer
+ *
+ * \class  ns3::AttributeContainerChecker "attribute-container.h"
+ * AttributeChecker implementation for AttributeContainerValue.
+ * \see AttributeChecker
+ */
 class AttributeContainerChecker : public AttributeChecker
 {
   public:
@@ -207,6 +222,8 @@
 };
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * Make AttributeContainerChecker from AttributeContainerValue.
  * @tparam A \deduced AttributeValue type in container.
  * @tparam Sep \deduced Character separator between elements for parsing.
@@ -219,6 +236,8 @@
     const AttributeContainerValue<A, Sep, C>& value);
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * Make AttributeContainerChecker using explicit types, initialize item checker.
  * @tparam A AttributeValue type in container.
  * @tparam Sep Character separator between elements for parsing.
@@ -230,6 +249,8 @@
 Ptr<const AttributeChecker> MakeAttributeContainerChecker(Ptr<const AttributeChecker> itemchecker);
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * Make uninitialized AttributeContainerChecker using explicit types.
  * @tparam A AttributeValue type in container.
  * @tparam Sep Character separator between elements for parsing.
@@ -240,6 +261,8 @@
 Ptr<AttributeChecker> MakeAttributeContainerChecker();
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * Make AttributeContainerAccessor  using explicit types.
  * @tparam A AttributeValue type in container.
  * @tparam Sep Character separator between elements for parsing.
@@ -254,6 +277,8 @@
 Ptr<const AttributeAccessor> MakeAttributeContainerAccessor(T1 a1);
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * Make AttributeContainerAccessor  using explicit types.
  * @tparam A AttributeValue type in container.
  * @tparam Sep Character separator between elements for parsing.
@@ -287,7 +312,10 @@
 {
 
 /**
+ * \ingroup attribute_AttributeContainer
+ *
  * \internal
+ *
  * Templated AttributeContainerChecker class that is instantiated
  * in MakeAttributeContainerChecker. The non-templated base ns3::AttributeContainerChecker
  * is returned from that function. This is the same pattern as ObjectPtrContainer.
